#include <stdio.h>
#include <string.h>

#include <algorithm>
#include <utility>

using namespace std;

const int NVT = 100000;
const int NAR = 100;

int N, M;
int val[NVT];
int adj[NVT][NAR], nadj[NVT];
int color[NVT];
int res[2][NVT];

void make_edge(int a, int b) {
	adj[a][nadj[a]++] = b;
	adj[b][nadj[b]++] = a;
}

bool dfs(int no, int c) {
	if (color[no] + c == 3) return false;
	if (color[no]) return true;
	color[no] = c;
	for (int p = 0; p < nadj[no]; p++) {
		int viz = adj[no][p];
		if (!dfs(viz, 3 - c)) return false;
	}
	return true;
}

int main(void) {
	scanf(" %d %d", &N, &M);
	for (int i = 0; i < N; i++) {
		scanf(" %d", &val[i]);
		nadj[i] = 0;
	}
	
	sort(val, val + N);
	for (int j = 0; j < M; j++) {
		int forb;
		scanf(" %d", &forb);
		int ini = 0, fim = N - 1;
		while (ini < fim) {
			int sum = val[ini] + val[fim];
			if      (sum < forb) ini++;
			else if (sum > forb) fim--;
			else               { make_edge(ini, fim); ini++; }
		}
	}
	
	bool ok = true;
	memset(color, 0, sizeof(color));
	for (int i = 0; i < N; i++) {
		if (color[i]) continue;
		if (!dfs(i, 1)) {
			ok = false;
			break;
		}
	}
	if (!ok) {
		printf("-1\n-1\n");
	} else {
		int ncolor[2] = {0, 0};
		for (int i = 0; i < N; i++) {
			int c = color[i] - 1;
			res[c][ncolor[c]++] = i;
		}
		for (int c = 0; c < 2; c++) {
			printf("%d", ncolor[c]);
			for (int k = 0; k < ncolor[c]; k++) {
				printf(" %d", val[res[c][k]]);
			}
			printf("\n");
		}
	}
	return 0;
}
